Subject: Re: git-p4 useclientspec broken?

From: Laurent Charrière <[email-masked]>
Date: Tue, 14 Feb 2012 15:25:44 -0800

On 2/14/12 4:36 AM, Pete Wyckoff wrote:
> [email-masked] wrote on Mon, 13 Feb 2012 16:47 -0800:
>> $ git p4 clone //sandbox/lcharriere/foo --use-client-spec
>> $ cd foo&&  find .
>> ./.git
>> (...)
>> ./sandbox/lcharriere/foo/.gitignore
>> ./sandbox/lcharriere/foo/foo.py
>>
>> -- This is new behavior to me, BTW. Previously, I would have seen
>> ./.git
>> (...)
>> ./.gitignore
>> ./foo.py
>
...
>
> The client spec now has absolute control over what files get put
> where in the git repo, just like in p4.  The argument
> "//sandbox/lcharriere/foo" in your clone command limits the scope
> of what is checked out, but does not affect where it is placed.
>
...
>
> Is this new behavior bad for you?  Suggestions welcome.

I like the new behavior just fine. I think it's more consistent with how 
p4 operates. I just wanted to point out the change in behavior, because 
I had not seen it called out, and it seemed relevant to my bug report.
The only disadvantage of the new behavior, IMHO, is the associated 
transition. When If you have an 'old-style' repo and do a git p4 rebase 
with 1.7.9, you find yourself in a situation where files are in two 
location, e.g. ./gitignore and ./sandbox/lcharriere/foo/.gitignore. So 
really you need to re-clone from p4. Not a big deal, but it is a little 
surprising.

>> $ cat "test">>  sandbox/lcharriere/foo/.gitignore
>> $ git commit -a -m "test"
>> git commit -a -m "test"
>> [master 7398144] test
>>   1 files changed, 1 insertions(+), 0 deletions(-)
>> $ git p4 submit
>> Perforce checkout for depot path //sandbox/lcharriere/foo/ located
>> at /Users/lcharriere/Documents/Perforce/all/sandbox/lcharriere/foo/
>> Synchronizing p4 checkout...
>> ... - file(s) up-to-date.
>> Applying 739814457a8faa84dc0bddd830f671569576b177 test
>>
>> sandbox/lcharriere/foo/.gitignore - file(s) not on client.
>> error: sandbox/lcharriere/foo/.gitignore: No such file or directory
>> Unfortunately applying the change failed!
>> What do you want to do?
>> [s]kip this patch / [a]pply the patch forcibly and with .rej files /
>> [w]rite the patch to a file (patch.txt)
>
> This is definitely a bug.  I reproduced a similar problem.
>
...
> I'll get a patch out tonight or soon.  Need to do gobs of testing
> on the submit path to make sure nothing else is broken.

Thanks, I appreciate your prompt reply.